#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <fun>

#define VIP_LEVEL ADMIN_LEVEL_H
#define keys_vip_menu (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<9)

new armor_mode[33]
new armor_active[33]

new grenades_mode[33]
new grenades_active[33]

new ammo_mode[33]
new ammo_active[33]

new money_mode[33]
new money_active[33]

new vampir_mode[33]
new vampir_active[33]

new sniper_mode[33]
new sniper_active[33]

new knife_mode[33]
new knife_active[33]
new k_only[33]

new roundendfix

public plugin_init()
{
        register_plugin("VIP Plugin", "0.0.0.4", "Brute")
	register_event("ResetHUD", "reset", "b")
	register_event("DeathMsg", "death_event", "a")
	register_logevent("event_round_end", 2, "0=World triggered", "1=Round_End")
	register_event("CurWeapon", "check_knife", "be", "1=1")
	register_event("CurWeapon", "check_sniper", "be", "1=1")
	register_cvar("vp", "1")
	register_cvar("vp_armor", "1")
	register_cvar("vp_grenades", "1")
	register_cvar("vp_ammo", "1")
	register_cvar("vp_money", "1")
	register_cvar("vp_money_num", "1000")
	register_cvar("vp_vampir", "1")
	register_cvar("vp_vampir_hp", "15")
	register_cvar("vp_sniper", "1")
	register_cvar("vp_knife", "1")
	register_cvar("vp_knife_hp", "300")
	register_menucmd(register_menuid("vip_menu"), keys_vip_menu, "pressed_vip_menu")
	register_clcmd("vip_menu","show_vip_menu")
}

public event_round_end()
{
	roundendfix=0
	set_task(1.0, "event_round_end_fix", 0)
	//client_print(0, print_chat, "[VIP PLUGIN]:test R1 = true")
}

public event_round_end_fix()
{
	roundendfix=1
	//client_print(0, print_chat, "[VIP PLUGIN]:test R2 = true")
}

public reset(id, level, cid)
{
	if(get_cvar_num("vp") != 0 && roundendfix==1)
	{
		if(get_user_flags(id) & VIP_LEVEL)
		{
			armor_active[id] = 0
			grenades_active[id] = 0
			ammo_active[id] = 0
			money_active[id] = 0
			vampir_active[id] = 0
			sniper_active[id] = 0
			knife_active[id] = 0
			if(armor_mode[id] == 1)
			{
				armor_active[id] = 1
				set_task(1.0, "vpar", id)
			}
			if(grenades_mode[id] == 1)
			{
				grenades_active[id] = 1
				set_task(1.0, "vpg", id)
			}
			if(ammo_mode[id] == 1)
			{
				ammo_active[id] = 1
				set_task(5.0, "vpa", id)
			}
			if(money_mode[id] == 1)
			{
				money_active[id] = 1
				set_task(1.0, "vpm", id)
			}
			if(vampir_mode[id] == 1)
			{
				vampir_active[id] = 1
			}
			if(sniper_mode[id] == 1)
			{
				sniper_active[id] = 1
			}
			if(knife_mode[id] == 1)
			{
				knife_active[id] = 1
				k_only[id] = 0
			}
			//client_print(id, print_chat, "[VIP PLUGIN]:RESET HUD!")
		}
	}
}


public vpar(id)
{
	if(armor_active[id] == 1)
	{
		give_item(id,"item_assaultsuit")
		client_print(id, print_chat, "[VIP PLUGIN]:You GIVE ARMOR+HELMET")
	}
}

public vpg(id)
{
	if(grenades_active[id] == 1)
	{
		give_item(id,"weapon_flashbang")
		give_item(id,"weapon_flashbang")
		give_item(id,"weapon_hegrenade")
		give_item(id,"weapon_smokegrenade")
		client_print(id, print_chat, "[VIP PLUGIN]:You GIVE GRENADES")
	}
}

public vpa(id)
{
	if(ammo_active[id] == 1)
	{
		cs_set_user_bpammo(id, CSW_USP, 100) 
       		cs_set_user_bpammo(id, CSW_ELITE, 120) 
        	cs_set_user_bpammo(id, CSW_DEAGLE, 35) 
        	cs_set_user_bpammo(id, CSW_GLOCK18, 120) 
        	cs_set_user_bpammo(id, CSW_P228, 52) 
        	cs_set_user_bpammo(id, CSW_FIVESEVEN, 100) 
        	cs_set_user_bpammo(id, CSW_XM1014, 32) 
        	cs_set_user_bpammo(id, CSW_M3, 32) 
        	cs_set_user_bpammo(id, CSW_P90, 100) 
        	cs_set_user_bpammo(id, CSW_MAC10, 100) 
        	cs_set_user_bpammo(id, CSW_MP5NAVY, 120) 
        	cs_set_user_bpammo(id, CSW_TMP, 120) 
        	cs_set_user_bpammo(id, CSW_UMP45, 100) 
        	cs_set_user_bpammo(id, CSW_FAMAS, 90) 
        	cs_set_user_bpammo(id, CSW_GALIL, 90) 
        	cs_set_user_bpammo(id, CSW_SCOUT, 90) 
        	cs_set_user_bpammo(id, CSW_AUG, 90) 
        	cs_set_user_bpammo(id, CSW_M4A1, 90) 
        	cs_set_user_bpammo(id, CSW_AK47, 90) 
        	cs_set_user_bpammo(id, CSW_SG552, 90) 
        	cs_set_user_bpammo(id, CSW_G3SG1, 90) 
        	cs_set_user_bpammo(id, CSW_SG552, 90) 
        	cs_set_user_bpammo(id, CSW_AWP, 30) 
        	cs_set_user_bpammo(id, CSW_M249, 200) 
		client_print(id, print_chat, "[VIP PLUGIN]:You GIVE AMMO")
	}
}

public vpm(id)
{
	if(money_active[id] == 1)
	{	
		cs_set_user_money(id, cs_get_user_money(id) + get_cvar_num("vp_money_num"))
		client_print(id, print_chat, "[VIP PLUGIN]:You GIVE %d MONEY", get_cvar_num("vp_money_num"))
	}
}

public death_event(id)
{
	new killer = read_data(1)
	if(vampir_active[killer] == 1)
	{
		set_user_health(killer, get_user_health(killer)+get_cvar_num("vp_vampir_hp"))
		client_print(killer, print_chat, "[VIP PLUGIN]:You GIVE %d HP",get_cvar_num("vp_vampir_hp"))
	}
}

public check_knife(id)
{
	if(knife_active[id] == 1 && k_only[id] == 0)
	{
		k_only[id] = 1
		strip_user_weapons(id)
		give_item(id,"weapon_knife")
		set_user_health(id, get_user_health(id)+get_cvar_num("vp_knife_hp"))
		client_print(id, print_chat, "[VIP PLUGIN]:You GIVE %d HP", get_cvar_num("vp_knife_hp"))
		client_print(id, print_chat, "[VIP PLUGIN]:KNIFE ONLY ENABLE")
	}
	if(knife_active[id] == 1 && k_only[id] == 1)
	{
		if(get_user_weapon(id) != CSW_KNIFE && get_user_weapon(id) != CSW_C4)
		{
			set_task(0.2, "drop_c4", id)
		}
	}
}

public drop_c4(id)
{
	engclient_cmd(id,"drop", "weapon_c4")
	set_task(0.2, "strip_weapons", id)
}

public strip_weapons(id)
{
	strip_user_weapons(id)
	set_task(0.2, "give_knife", id)
}

public give_knife(id)
{
	give_item(id,"weapon_knife")
}

public check_sniper(id)
{
	if(sniper_active[id] == 1)
	{

	}
	else if(sniper_active[id] == 0)
	{
		set_task(0.5, "drop_sniper", id)
	}
}
public drop_sniper(id)
{
	if(get_user_weapon(id) == CSW_SCOUT)
	{
		engclient_cmd(id,"drop", "weapon_scout")
		client_print(id, print_chat, "[VIP PLUGIN]:SNIPERS WEAPONS FOR VIP'S ONLY!")
	}
	if(get_user_weapon(id) == CSW_SG550)
	{
		engclient_cmd(id,"drop", "weapon_sg550")
		client_print(id, print_chat, "[VIP PLUGIN]:SNIPERS WEAPONS FOR VIP'S ONLY!")
	}
	if(get_user_weapon(id) == CSW_AWP)
	{
		engclient_cmd(id,"drop", "weapon_awp")
		client_print(id, print_chat, "[VIP PLUGIN]:SNIPERS WEAPONS FOR VIP'S ONLY!")
	}
	if(get_user_weapon(id) == CSW_G3SG1)
	{
		engclient_cmd(id,"drop", "weapon_g3sg1")
		client_print(id, print_chat, "[VIP PLUGIN]:SNIPERS WEAPONS FOR VIP'S ONLY!")
	}
}
public show_vip_menu(id, level, cid)
{
	if(get_user_flags(id) & VIP_LEVEL)
	{
		if(get_cvar_num("vp") == 1)
		{
			new szMenuBody[1024]
			new len  = format(szMenuBody, 1023, "\rVIP Menu^n")
			len += format(szMenuBody[len], 1023-len, "")
			if(armor_mode[id] == 0 && get_cvar_num("vp_armor") == 1)
				len += format(szMenuBody[len], 1023-len, "^n\r1. \yKevlar And Helmet")
			if(armor_mode[id] == 1 || get_cvar_num("vp_armor") == 0)
				len += format(szMenuBody[len], 1023-len, "^n\r1. \dKevlar And Helmet")
			if(grenades_mode[id] == 0 && get_cvar_num("vp_grenades") == 1)
				len += format(szMenuBody[len], 1023-len, "^n\r2. \yGrenades")
			if(grenades_mode[id] == 1 || get_cvar_num("vp_grenades") == 0)
				len += format(szMenuBody[len], 1023-len, "^n\r2. \dGrenades")
			if(ammo_mode[id] == 0 && get_cvar_num("vp_ammo") == 1)
				len += format(szMenuBody[len], 1023-len, "^n\r3. \yAmmo")
			if(ammo_mode[id] == 1 || get_cvar_num("vp_ammo") == 0)
				len += format(szMenuBody[len], 1023-len, "^n\r3. \dAmmo")
			if(money_mode[id] == 0 && get_cvar_num("vp_money") == 1)
				len += format(szMenuBody[len], 1023-len, "^n\r4. \yMoney")
			if(money_mode[id] == 1 || get_cvar_num("vp_money") == 0)
				len += format(szMenuBody[len], 1023-len, "^n\r4. \dMoney")
			if(vampir_mode[id] == 0 && get_cvar_num("vp_vampir") == 1)
				len += format(szMenuBody[len], 1023-len, "^n\r5. \yVampir")
			if(vampir_mode[id] == 1 || get_cvar_num("vp_vampir") == 0)
				len += format(szMenuBody[len], 1023-len, "^n\r5. \dVampir")
			if(sniper_mode[id] == 0 && get_cvar_num("vp_sniper") == 1)
				len += format(szMenuBody[len], 1023-len, "^n\r6. \ySniper")
			if(sniper_mode[id] == 1 || get_cvar_num("vp_sniper") == 0)
				len += format(szMenuBody[len], 1023-len, "^n\r6. \dSniper")
			if(knife_mode[id] == 0 && get_cvar_num("vp_ammo") == 1)
				len += format(szMenuBody[len], 1023-len, "^n\r7. \yKnife")
			if(knife_mode[id] == 1 || get_cvar_num("vp_ammo") == 0)
				len += format(szMenuBody[len], 1023-len, "^n\r7. \dKnife")
			len += format(szMenuBody[len], 1023-len, "^n")
			len += format(szMenuBody[len], 1023-len, "^n\r8. \yDisable ALL Modes")
			len += format(szMenuBody[len], 1023-len, "^n")
			len += format(szMenuBody[len], 1023-len, "^n\r0. \yExit^n")
			show_menu(id, keys_vip_menu, szMenuBody, -1, "vip_menu")
		}
		else if(get_cvar_num("vp") != 1)
		{
			client_print(id, print_center, "[VIP PLUGIN]:Vip Menu Disable")
		}
	}
	else if(get_user_flags(id) != VIP_LEVEL)
	{
		client_print(id, print_center, "[VIP PLUGIN]:ACCES FAILED")
	}
	return PLUGIN_HANDLED
}

public pressed_vip_menu(id, key)
{
	switch (key)
	{
		case 0:
		{
			if(armor_mode[id] == 0 && get_cvar_num("vp_armor") == 1)
			{
				armor_mode[id] = 1
				grenades_mode[id] = 0
				ammo_mode[id] = 0
				money_mode[id] = 0
				vampir_mode[id] = 0
				sniper_mode[id] = 0
				knife_mode[id] = 0
				client_print(id, print_chat, "[VIP PLUGIN]:You ENABLE ARMOR+HELMET MODE")
			}
			if(get_cvar_num("vp_armor") == 0)
			{
				client_print(id, print_chat, "[VIP PLUGIN]:ADMIN DISABLE ARMOR+HELMET MODE")
			}
		}
		case 1:
		{
			if(grenades_mode[id] == 0 && get_cvar_num("vp_grenades") == 1)
			{
				armor_mode[id] = 0
				grenades_mode[id] = 1
				ammo_mode[id] = 0
				money_mode[id] = 0
				vampir_mode[id] = 0
				sniper_mode[id] = 0
				knife_mode[id] = 0
				client_print(id, print_chat, "[VIP PLUGIN]:You ENABLE GRENADES MODE")
			}

			if(get_cvar_num("vp_grenades") == 0)
			{
				client_print(id, print_chat, "[VIP PLUGIN]:ADMIN DISABLE GRENADES MODE")
			}
		}
		case 2:
		{
			if(ammo_mode[id] == 0 && get_cvar_num("vp_ammo") == 1)
			{
				armor_mode[id] = 0
				grenades_mode[id] = 0
				ammo_mode[id] = 1
				money_mode[id] = 0
				vampir_mode[id] = 0
				sniper_mode[id] = 0
				knife_mode[id] = 0
				client_print(id, print_chat, "[VIP PLUGIN]:You ENABLE AMMO MODE")
			}
			if(get_cvar_num("vp_ammo") == 0)
			{
				client_print(id, print_chat, "[VIP PLUGIN]:ADMIN DISABLE AMMO MODE")
			}
		}
		case 3:
		{
			if(money_mode[id] == 0 && get_cvar_num("vp_money") == 1)
			{
				armor_mode[id] = 0
				grenades_mode[id] = 0
				ammo_mode[id] = 0
				money_mode[id] = 1
				vampir_mode[id] = 0
				sniper_mode[id] = 0
				knife_mode[id] = 0
				client_print(id, print_chat, "[VIP PLUGIN]:You ENABLE MONEY MODE")
			}
			if(get_cvar_num("vp_money") == 0)
			{
				client_print(id, print_chat, "[VIP PLUGIN]:ADMIN DISABLE MONEY MODE")
			}
		}
		case 4:
		{
			if(vampir_mode[id] == 0 && get_cvar_num("vp_vampir") == 1)
			{
				armor_mode[id] = 0
				grenades_mode[id] = 0
				ammo_mode[id] = 0
				money_mode[id] = 0
				vampir_mode[id] = 1
				sniper_mode[id] = 0
				knife_mode[id] = 0
				client_print(id, print_chat, "[VIP PLUGIN]:You ENABLE VAMPIR MODE")
			}
			if(get_cvar_num("vp_vampir") == 0)
			{
				client_print(id, print_chat, "[VIP PLUGIN]:ADMIN DISABLE VAMPIR MODE")
			}
		}
		case 5:
		{
			if(sniper_mode[id] == 0 && get_cvar_num("vp_sniper") == 1)
			{
				armor_mode[id] = 0
				grenades_mode[id] = 0
				ammo_mode[id] = 0
				money_mode[id] = 0
				vampir_mode[id] = 0
				sniper_mode[id] = 1
				knife_mode[id] = 0
				client_print(id, print_chat, "[VIP PLUGIN]:You ENABLE SNIPER MODE")
			}
			if(get_cvar_num("vp_sniper") == 0)
			{
				client_print(id, print_chat, "[VIP PLUGIN]:ADMIN DISABLE SNIPER MODE")
			}
		}
		case 6:
		{
			if(knife_mode[id] == 0 && get_cvar_num("vp_knife") == 1)
			{
				armor_mode[id] = 0
				grenades_mode[id] = 0
				ammo_mode[id] = 0
				money_mode[id] = 0
				vampir_mode[id] = 0
				sniper_mode[id] = 0
				knife_mode[id] = 1
				client_print(id, print_chat, "[VIP PLUGIN]:You ENABLE KNIFE MODE")
			}
			if(get_cvar_num("vp_knife") == 0)
			{
				client_print(id, print_chat, "[VIP PLUGIN]:ADMIN DISABLE KNIFE MODE")
			}
		}
		case 7:
		{
			armor_mode[id] = 0
			grenades_mode[id] = 0
			ammo_mode[id] = 0
			money_mode[id] = 0
			vampir_mode[id] = 0
			sniper_mode[id] = 0
			knife_mode[id] = 0
			client_print(id, print_chat, "[VIP PLUGIN]:You DISABLE ALL MODES")
		}
	}
}